
// SET THE HEIGHT OF THE BALLS OVER TIME 't'

void setHeight() {
  randomSeed(0);
  
  for (int x = 0; x < xSize; x++) {
    for (int y = 0; y < ySize; y++) {
      
      // this loops through all the balls in x and y 
      // the t (time) variable increments everyframe so use this number to animate parameters.
      
      // INSERT YOUR FUNCTION BELOW (remove the existing functions between the lines)
      
      ///////////////////////////////////////////////////////////////
      
      float r = 2*PI + random(0.2, 0.8);

      // add sinewave behaviour
      ballZ[x][y] = waveMultiplier*( tideLevel*0.6+amp1*ampMultiplier*sin(t+(float)x*freqMultiplier*freq1 - (float)y*freqMultiplier*freq2) + 
                    tideLevel*0.4+amp2*ampMultiplier*cos(t+(float)x*freqMultiplier*freq2 + (float)y*freq1*freqMultiplier) );

      // add noise behaviour
      ballZ[x][y] += (extraNoise+noiseMultiplier)*( tan(r)*(aveVol+10)*10*noise(t*r*r*0.02+r*100) );

      // add height offset
      ballZ[x][y] += heightOffset;
      
      ///////////////////////////////////////////////////////////////

      allBallZ[x+7*y] = (int)(constrain(abs(ballZ[x][y]), 0, 255));
    }
  }
  
}



// SET THE COLOUR OF THE BALLS   

void setColor() {

  for (int i = 0; i < xSize; i++) {
    for (int j = 0; j < ySize; j++) {
      
            // this loops through all the balls in x and y 
      // the t (time) variable increments everyframe so use this number to animate parameters.
      
      // INSERT YOUR FUNCTION BELOW 
      
      ///////////////////////////////////////////////////////////////

      if (colorMode == 1) {
        colorMode(RGB);
        c1 = cp1.getColorValue();
        c2 = cp2.getColorValue();

        if (changing) {
          ballC[i][j] = lerpColor(tempC[i][j], lerpColor(lerpColor(c2, c1, (float)(i+j)/(xSize+ySize-5)), color(255), (float)(i+(ySize-j))/(xSize+ySize+10)), cT);
        } else {
          ballC[i][j] = lerpColor(c2, c1, (float)(i+j)/(xSize+ySize-5));
          ballC[i][j] = lerpColor(ballC[i][j], color(255, 0, 0), (float)(i+(ySize-j))/(xSize+ySize+10));
        }
      }

      if (colorMode == 2) {
        colorMode(HSB);
        if (changing) {
          ballC[i][j] = lerpColor(tempC[i][j], color(map(ballZ[i][j], 0, 180, 150, 0), 255, 255), cT);
        } else {
          ballC[i][j] = color(constrain(map(ballZ[i][j], 0, 180, 150, 0), 0, 255), 255, 255);
        }
      }

      if (colorMode == 3) {
        colorMode(RGB);
        //sets the day colour (c1 and c2) every 2 mins
        //if (minute()%2 == 0) setDayColor();
        if (second()%2 == 0) setDayColor();

        if (changing) {
          ballC[i][j] = lerpColor(tempC[i][j], lerpColor(c2, c1, (float)(i+j)/(xSize+ySize-2)), cT);
        } else {
          ballC[i][j] = lerpColor(c2, c1, (float)(i+j)/(xSize+ySize-5));
          //ballC[i][j] = lerpColor(ballC[i][j], color(255), (float)(i+(ySize-j))/(xSize+ySize+10));
        }
      }
      
      
      ///////////////////////////////////////////////////////////////
      
      // remove this last bit if you want to disable the "clap" flash behaviour

      if (claps.size() > 0) {
        for (Clap c : claps) {
          float dist = dist(i, j, c.x, c.y);
          if ( abs(dist-(c.t)*10) < 0.5) ballC[i][j] = color(255);
        }
      }
    }
  }
}

void setDayColor() {

  float colorVal = constrain(map(hour()+minute()*0.016, 8, 21, 0, 1), 0, 1);

  c1 = day1.getGradient( colorVal );
  c2 = day2.getGradient( colorVal );
}

















// WRITE THE DMX SIGNALS

void writeHeightToDMX() {

  for (int x = 0; x < xSize; x++) {
    for (int y = 0; y < ySize; y++) {

      int v = allBallZ[x+7*y];

      if (x==3 && y==2 && v>12) v -= 12;


      int channel = (x+y*7)*7;

      if (v != tempHeight[x][y]) dmxHeight.setDMXChannel( channel, v);
      tempHeight[x][y] = v;
    }
  }
}

void writeColorsToDMX() {

  // insert RGB DMX protocol

  for (int x = 0; x < xSize; x++) {
    for (int y = 0; y < ySize; y++) {

      int channel = (x+7*y)*3;

      if (!resetting) {
        if (ballC[x][y] != prevC[x][y]) {

          dmxLight.setDMXChannel( channel + 0, int(red(ballC[x][y])));
          dmxLight.setDMXChannel( channel + 1, int(green(ballC[x][y])));
          dmxLight.setDMXChannel( channel + 2, int(blue(ballC[x][y])));

          prevC[x][y] = ballC[x][y];
        }
      } else {
        dmxLight.setDMXChannel( channel + 0, 255);
        dmxLight.setDMXChannel( channel + 1, 255);
        dmxLight.setDMXChannel( channel + 2, 255);
      }
    }
  }
}
